<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: C:/Data/Git/MeLOn/common/inc/kernel.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('kernel_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">kernel.h</div></div>
</div><!--header-->
<div class="contents">
<a href="kernel_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/***********************************************************************************</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment">* Copyright (c) 2020 Process Systems Engineering (AVT.SVT), RWTH Aachen University</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment">*</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment">* This program and the accompanying materials are made available under the</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment">* terms of the Eclipse Public License 2.0 which is available at</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment">* http://www.eclipse.org/legal/epl-2.0.</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment">*</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment">* SPDX-License-Identifier: EPL-2.0</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment">*</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment">* @file kernel.h</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment">* @brief File containing declaration of kernel classes</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment">*</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment">**********************************************************************************/</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
<div class="foldopen" id="foldopen00021" data-start="{" data-end="}">
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="namespacemelon.html">   21</a></span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacemelon.html">melon</a> {</div>
<div class="foldopen" id="foldopen00022" data-start="{" data-end="}">
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="namespacemelon_1_1kernel.html">   22</a></span>    <span class="keyword">namespace </span>kernel {</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00029" data-start="{" data-end="};">
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel.html">   29</a></span>        <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel</a> {</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>        <span class="keyword">public</span>:</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>            <span class="comment">// Deduces kernel return type, depending on template parameters</span></div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">   33</a></span>            <span class="keyword">using </span><a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> = <span class="keyword">decltype</span>(std::declval&lt;T&gt;() + std::declval&lt;V&gt;());</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span> </div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel.html#a723ab0686bbb045ff401220d51f72c2a">   38</a></span>            <span class="keyword">virtual</span> <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel.html#a723ab0686bbb045ff401220d51f72c2a">~Kernel</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span> </div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel.html#a8ec36af697437b1a9b6ff84efb237e14">   49</a></span>            <span class="keyword">virtual</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel.html#a8ec36af697437b1a9b6ff84efb237e14">evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) = 0;</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>        };</div>
</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span> </div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00058" data-start="{" data-end="};">
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_stationary_kernel.html">   58</a></span>        <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_stationary_kernel.html">StationaryKernel</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel</a>&lt;T, V&gt; {</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>        <span class="keyword">public</span>:</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span> </div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>            <span class="keyword">using </span>typename <a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel&lt;T, V&gt;</a> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">::RET</a>;</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span> </div>
<div class="foldopen" id="foldopen00070" data-start="{" data-end="}">
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_stationary_kernel.html#a566162476b5a4d85bf3433131bc517ae">   70</a></span>            <span class="keyword">virtual</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_stationary_kernel.html#a566162476b5a4d85bf3433131bc517ae">_quadratic_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>                <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance = 0;</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span> </div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>                <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; x1.size(); i++) {        <span class="comment">// i the demension of X and X_test</span></div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>                    distance += pow(x1.at(i) - x2.at(i), 2);</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>                }</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span> </div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>                <span class="keywordflow">return</span> distance;</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>            };</div>
</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_stationary_kernel.html#ae9793199628aa2042e9e546965400db5">   87</a></span>            <span class="keyword">virtual</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_stationary_kernel.html#ae9793199628aa2042e9e546965400db5">evaluate_kernel</a>(<a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance) = 0; <span class="comment">// works only for stationary kernels</span></div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span> </div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_stationary_kernel.html#a6879c9fdde3f47097c7316939345cf4e">   98</a></span>            <span class="keyword">virtual</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_stationary_kernel.html#a6879c9fdde3f47097c7316939345cf4e">calculate_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) = 0;</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>        };</div>
</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span> </div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span> </div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00107" data-start="{" data-end="};">
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_composite_add.html">  107</a></span>        <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel_composite_add.html">KernelCompositeAdd</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel</a>&lt;T, V&gt; {</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        <span class="keyword">public</span>:</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span> </div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>            <span class="keyword">using </span>typename <a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel&lt;T, V&gt;</a> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">::RET</a>;</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span> </div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a13bb991f5bad35ed9e0601cae676db99">  117</a></span>            <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a13bb991f5bad35ed9e0601cae676db99">add</a>(std::shared_ptr&lt;<a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel&lt;T, V&gt;</a>&gt; kernel) { <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a252d76caee37fdbc77312bb099a04760">children</a>.push_back(kernel); }</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span> </div>
<div class="foldopen" id="foldopen00128" data-start="{" data-end="}">
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a2af41f4a028e420edaca18501bf10a58">  128</a></span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a2af41f4a028e420edaca18501bf10a58">evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>                <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> value = 0;</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>                <span class="keywordflow">for</span> (<span class="keyword">auto</span> kernel : <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a252d76caee37fdbc77312bb099a04760">children</a>) {</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>                    value += kernel-&gt;evaluate_kernel(x1, x2);</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>                }</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>                <span class="keywordflow">return</span> value;</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>            }</div>
</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span> </div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>        <span class="keyword">private</span>:</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a252d76caee37fdbc77312bb099a04760">  137</a></span>            std::vector&lt;std::shared_ptr&lt;Kernel&lt;T, V&gt;&gt;&gt; <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a252d76caee37fdbc77312bb099a04760">children</a>;   </div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>        };</div>
</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span> </div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00145" data-start="{" data-end="};">
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html">  145</a></span>        <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html">KernelCompositeMultiply</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel</a>&lt;T, V&gt; {</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>        <span class="keyword">public</span>:</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span> </div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>            <span class="keyword">using </span>typename <a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel&lt;T, V&gt;</a> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">::RET</a>;</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span> </div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#a6ddb3671f06cdbca154ae1c070323853">  155</a></span>            <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#a6ddb3671f06cdbca154ae1c070323853">add</a>(std::shared_ptr&lt;<a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel&lt;T, V&gt;</a>&gt; kernel) { <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#aa1451991c1bafd1fbd172f3553b2f06b">children</a>.push_back(kernel); }</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span> </div>
<div class="foldopen" id="foldopen00166" data-start="{" data-end="}">
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#a39cea278adc79c371f3a05cb61631ecb">  166</a></span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#a39cea278adc79c371f3a05cb61631ecb">evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>                <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> value = 1;</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>                <span class="keywordflow">for</span> (<span class="keyword">auto</span> kernel : <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#aa1451991c1bafd1fbd172f3553b2f06b">children</a>) {</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>                    value *= kernel-&gt;k(x1, x2);</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>                }</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>                <span class="keywordflow">return</span> value;</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>            }</div>
</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span> </div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>        <span class="keyword">private</span>:</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#aa1451991c1bafd1fbd172f3553b2f06b">  175</a></span>            std::vector&lt;std::shared_ptr&lt;Kernel&lt;T, V&gt;&gt;&gt; <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#aa1451991c1bafd1fbd172f3553b2f06b">children</a>;       </div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>        };</div>
</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span> </div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00183" data-start="{" data-end="};">
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_constant.html">  183</a></span>        <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel_constant.html">KernelConstant</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel</a>&lt;T, V&gt; {</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>        <span class="keyword">public</span>:</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span> </div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>            <span class="keyword">using </span>typename <a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel&lt;T, V&gt;</a> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">::RET</a>;</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span> </div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_constant.html#a90c34c40cc180f0c3fe8b48f3e26ea77">  191</a></span>            <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_constant.html#a90c34c40cc180f0c3fe8b48f3e26ea77">KernelConstant</a>() : <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_constant.html#a1ec7738aa8621712f7fa706861b81a86">_f</a>(1) {};</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span> </div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_constant.html#a8ae85b101e179697f2a8b71e3aa60f49">  198</a></span>            <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_constant.html#a8ae85b101e179697f2a8b71e3aa60f49">KernelConstant</a>(<span class="keyword">const</span> T f) : <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_constant.html#a1ec7738aa8621712f7fa706861b81a86">_f</a>(f) {};</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span> </div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_constant.html#ab46d81c3502ecef318700c88fbeb7dee">  205</a></span>            <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_constant.html#ab46d81c3502ecef318700c88fbeb7dee">KernelConstant</a>(<span class="keyword">const</span> V f) : <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_constant.html#a1ec7738aa8621712f7fa706861b81a86">_f</a>(f) {};</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span> </div>
<div class="foldopen" id="foldopen00216" data-start="{" data-end="}">
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_constant.html#a6bdac5c342fb8b15b5dee84d41443216">  216</a></span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_constant.html#a6bdac5c342fb8b15b5dee84d41443216">evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>                <span class="keywordflow">return</span> <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_constant.html#a1ec7738aa8621712f7fa706861b81a86">_f</a>;</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>            }</div>
</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span> </div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>        <span class="keyword">private</span>:</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_constant.html#a1ec7738aa8621712f7fa706861b81a86">  221</a></span>            <span class="keyword">const</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_constant.html#a1ec7738aa8621712f7fa706861b81a86">_f</a>;     </div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>        };</div>
</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span> </div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span> </div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00230" data-start="{" data-end="};">
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">  230</a></span>        <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">KernelRBF</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_stationary_kernel.html">StationaryKernel</a>&lt;T, V&gt; {</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>        <span class="keyword">public</span>:</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span> </div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>            <span class="keyword">using </span>typename <a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel.html">Kernel&lt;T, V&gt;</a> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">::RET</a>;</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span> </div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#aebf09200ca3535f515384f9326978359">  240</a></span>            <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#aebf09200ca3535f515384f9326978359">KernelRBF</a>(<span class="keyword">const</span> <span class="keywordtype">double</span> gamma) : <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a8885cc1731e50ae7b5f9bc0bef44748e">_gamma</a>(gamma) {};</div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span> </div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span> </div>
<div class="foldopen" id="foldopen00252" data-start="{" data-end="}">
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#af77cb8a39caa7d5191aa560eb80d2f09">  252</a></span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#af77cb8a39caa7d5191aa560eb80d2f09">evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2)<span class="keyword"> override </span>{</div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span> </div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>                <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance = <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a1fb033bbe5a2ed283fcecc2a0a34bb84">calculate_distance</a>(x1, x2);</div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>                <span class="keywordflow">return</span> <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#af77cb8a39caa7d5191aa560eb80d2f09">evaluate_kernel</a>(distance);</div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span>            }</div>
</div>
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span> </div>
<div class="foldopen" id="foldopen00267" data-start="{" data-end="}">
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a1fb033bbe5a2ed283fcecc2a0a34bb84">  267</a></span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a1fb033bbe5a2ed283fcecc2a0a34bb84">calculate_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2)<span class="keyword"> override </span>{</div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span>                <span class="keywordflow">return</span> this-&gt;<a class="code hl_function" href="classmelon_1_1kernel_1_1_stationary_kernel.html#a566162476b5a4d85bf3433131bc517ae">_quadratic_distance</a>(x1, x2);</div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>            }</div>
</div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span> </div>
<div class="foldopen" id="foldopen00278" data-start="{" data-end="}">
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a8bfc02f818e464515cf4eee385e4451e">  278</a></span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a8bfc02f818e464515cf4eee385e4451e">evaluate_kernel</a>(<a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance)<span class="keyword"> override </span>{</div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span> </div>
<div class="line"><a id="l00280" name="l00280"></a><span class="lineno">  280</span>                <span class="keywordflow">return</span> exp(-<a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a8885cc1731e50ae7b5f9bc0bef44748e">_gamma</a> * distance);</div>
<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span> </div>
<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>            }</div>
</div>
<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span> </div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span>        <span class="keyword">private</span>:</div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a8885cc1731e50ae7b5f9bc0bef44748e">  285</a></span>            <span class="keyword">const</span> <span class="keywordtype">double</span> <a class="code hl_variable" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a8885cc1731e50ae7b5f9bc0bef44748e">_gamma</a>;</div>
<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span>        };</div>
</div>
<div class="line"><a id="l00287" name="l00287"></a><span class="lineno">  287</span> </div>
<div class="line"><a id="l00288" name="l00288"></a><span class="lineno">  288</span>    }</div>
</div>
<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span> </div>
<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span>}</div>
</div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_composite_add_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_composite_add.html">melon::kernel::KernelCompositeAdd</a></div><div class="ttdoc">Composite kernel which on evaluation adds the evaluation results of its subkernels.</div><div class="ttdef"><b>Definition</b> kernel.h:107</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_composite_add_html_a13bb991f5bad35ed9e0601cae676db99"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a13bb991f5bad35ed9e0601cae676db99">melon::kernel::KernelCompositeAdd::add</a></div><div class="ttdeci">void add(std::shared_ptr&lt; Kernel&lt; T, V &gt; &gt; kernel)</div><div class="ttdoc">Function for adding another subkernel to the composite kernel.</div><div class="ttdef"><b>Definition</b> kernel.h:117</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_composite_add_html_a252d76caee37fdbc77312bb099a04760"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a252d76caee37fdbc77312bb099a04760">melon::kernel::KernelCompositeAdd::children</a></div><div class="ttdeci">std::vector&lt; std::shared_ptr&lt; Kernel&lt; T, V &gt; &gt; &gt; children</div><div class="ttdef"><b>Definition</b> kernel.h:137</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_composite_add_html_a2af41f4a028e420edaca18501bf10a58"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a2af41f4a028e420edaca18501bf10a58">melon::kernel::KernelCompositeAdd::evaluate_kernel</a></div><div class="ttdeci">RET evaluate_kernel(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Function for evalualting the kernel.</div><div class="ttdef"><b>Definition</b> kernel.h:128</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_composite_multiply_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html">melon::kernel::KernelCompositeMultiply</a></div><div class="ttdoc">Composite kernel which on evaluation multiplies the evaluation results of its subkernels.</div><div class="ttdef"><b>Definition</b> kernel.h:145</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_composite_multiply_html_a39cea278adc79c371f3a05cb61631ecb"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#a39cea278adc79c371f3a05cb61631ecb">melon::kernel::KernelCompositeMultiply::evaluate_kernel</a></div><div class="ttdeci">RET evaluate_kernel(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Function for evalualting the kernel.</div><div class="ttdef"><b>Definition</b> kernel.h:166</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_composite_multiply_html_a6ddb3671f06cdbca154ae1c070323853"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#a6ddb3671f06cdbca154ae1c070323853">melon::kernel::KernelCompositeMultiply::add</a></div><div class="ttdeci">void add(std::shared_ptr&lt; Kernel&lt; T, V &gt; &gt; kernel)</div><div class="ttdoc">Function for adding another subkernel to the composite kernel.</div><div class="ttdef"><b>Definition</b> kernel.h:155</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_composite_multiply_html_aa1451991c1bafd1fbd172f3553b2f06b"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#aa1451991c1bafd1fbd172f3553b2f06b">melon::kernel::KernelCompositeMultiply::children</a></div><div class="ttdeci">std::vector&lt; std::shared_ptr&lt; Kernel&lt; T, V &gt; &gt; &gt; children</div><div class="ttdef"><b>Definition</b> kernel.h:175</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_constant_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_constant.html">melon::kernel::KernelConstant</a></div><div class="ttdoc">Kernel which always returns a constant value.</div><div class="ttdef"><b>Definition</b> kernel.h:183</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_constant_html_a1ec7738aa8621712f7fa706861b81a86"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_constant.html#a1ec7738aa8621712f7fa706861b81a86">melon::kernel::KernelConstant::_f</a></div><div class="ttdeci">const RET _f</div><div class="ttdef"><b>Definition</b> kernel.h:221</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_constant_html_a6bdac5c342fb8b15b5dee84d41443216"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_constant.html#a6bdac5c342fb8b15b5dee84d41443216">melon::kernel::KernelConstant::evaluate_kernel</a></div><div class="ttdeci">RET evaluate_kernel(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Function for evalualting the kernel.</div><div class="ttdef"><b>Definition</b> kernel.h:216</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_constant_html_a8ae85b101e179697f2a8b71e3aa60f49"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_constant.html#a8ae85b101e179697f2a8b71e3aa60f49">melon::kernel::KernelConstant::KernelConstant</a></div><div class="ttdeci">KernelConstant(const T f)</div><div class="ttdoc">Constructor.</div><div class="ttdef"><b>Definition</b> kernel.h:198</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_constant_html_a90c34c40cc180f0c3fe8b48f3e26ea77"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_constant.html#a90c34c40cc180f0c3fe8b48f3e26ea77">melon::kernel::KernelConstant::KernelConstant</a></div><div class="ttdeci">KernelConstant()</div><div class="ttdoc">Constructor. Initializes the kernels return value to 1.</div><div class="ttdef"><b>Definition</b> kernel.h:191</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_constant_html_ab46d81c3502ecef318700c88fbeb7dee"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_constant.html#ab46d81c3502ecef318700c88fbeb7dee">melon::kernel::KernelConstant::KernelConstant</a></div><div class="ttdeci">KernelConstant(const V f)</div><div class="ttdoc">Constructor.</div><div class="ttdef"><b>Definition</b> kernel.h:205</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel.html">melon::kernel::Kernel</a></div><div class="ttdoc">Abstract parent class for kernel implementations.</div><div class="ttdef"><b>Definition</b> kernel.h:29</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_html_a723ab0686bbb045ff401220d51f72c2a"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel.html#a723ab0686bbb045ff401220d51f72c2a">melon::kernel::Kernel::~Kernel</a></div><div class="ttdeci">virtual ~Kernel()=default</div><div class="ttdoc">Destructor.</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_html_a8ec36af697437b1a9b6ff84efb237e14"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel.html#a8ec36af697437b1a9b6ff84efb237e14">melon::kernel::Kernel::evaluate_kernel</a></div><div class="ttdeci">virtual RET evaluate_kernel(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)=0</div><div class="ttdoc">Function for evalualting the kernel for the points x1 and x2.</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_html_afc65772b466950a64138b8914d44a0b1"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">melon::kernel::Kernel::RET</a></div><div class="ttdeci">decltype(std::declval&lt; T &gt;()+std::declval&lt; V &gt;()) RET</div><div class="ttdef"><b>Definition</b> kernel.h:33</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_r_b_f_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">melon::kernel::KernelRBF</a></div><div class="ttdoc">Implementation of Radial Basis Function kernel.</div><div class="ttdef"><b>Definition</b> kernel.h:230</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_r_b_f_html_a1fb033bbe5a2ed283fcecc2a0a34bb84"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a1fb033bbe5a2ed283fcecc2a0a34bb84">melon::kernel::KernelRBF::calculate_distance</a></div><div class="ttdeci">RET calculate_distance(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2) override</div><div class="ttdoc">Function for calculating the distance used in the kernel (type of distance used can vary among kernel...</div><div class="ttdef"><b>Definition</b> kernel.h:267</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_r_b_f_html_a8885cc1731e50ae7b5f9bc0bef44748e"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a8885cc1731e50ae7b5f9bc0bef44748e">melon::kernel::KernelRBF::_gamma</a></div><div class="ttdeci">const double _gamma</div><div class="ttdef"><b>Definition</b> kernel.h:285</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_r_b_f_html_a8bfc02f818e464515cf4eee385e4451e"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#a8bfc02f818e464515cf4eee385e4451e">melon::kernel::KernelRBF::evaluate_kernel</a></div><div class="ttdeci">RET evaluate_kernel(RET distance) override</div><div class="ttdoc">Function for evalualting the kernel for a given distance.</div><div class="ttdef"><b>Definition</b> kernel.h:278</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_r_b_f_html_aebf09200ca3535f515384f9326978359"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#aebf09200ca3535f515384f9326978359">melon::kernel::KernelRBF::KernelRBF</a></div><div class="ttdeci">KernelRBF(const double gamma)</div><div class="ttdoc">Constructor.</div><div class="ttdef"><b>Definition</b> kernel.h:240</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_r_b_f_html_af77cb8a39caa7d5191aa560eb80d2f09"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#af77cb8a39caa7d5191aa560eb80d2f09">melon::kernel::KernelRBF::evaluate_kernel</a></div><div class="ttdeci">RET evaluate_kernel(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2) override</div><div class="ttdoc">Function for evalualting the kernel.</div><div class="ttdef"><b>Definition</b> kernel.h:252</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_stationary_kernel_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_stationary_kernel.html">melon::kernel::StationaryKernel</a></div><div class="ttdef"><b>Definition</b> kernel.h:58</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_stationary_kernel_html_a566162476b5a4d85bf3433131bc517ae"><div class="ttname"><a href="classmelon_1_1kernel_1_1_stationary_kernel.html#a566162476b5a4d85bf3433131bc517ae">melon::kernel::StationaryKernel::_quadratic_distance</a></div><div class="ttdeci">virtual RET _quadratic_distance(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Calculates the quadratic distance between two points x1 and x2.</div><div class="ttdef"><b>Definition</b> kernel.h:70</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_stationary_kernel_html_a6879c9fdde3f47097c7316939345cf4e"><div class="ttname"><a href="classmelon_1_1kernel_1_1_stationary_kernel.html#a6879c9fdde3f47097c7316939345cf4e">melon::kernel::StationaryKernel::calculate_distance</a></div><div class="ttdeci">virtual RET calculate_distance(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)=0</div><div class="ttdoc">Function for calculating the distance used in the kernel (type of distance used can vary among kernel...</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_stationary_kernel_html_ae9793199628aa2042e9e546965400db5"><div class="ttname"><a href="classmelon_1_1kernel_1_1_stationary_kernel.html#ae9793199628aa2042e9e546965400db5">melon::kernel::StationaryKernel::evaluate_kernel</a></div><div class="ttdeci">virtual RET evaluate_kernel(RET distance)=0</div><div class="ttdoc">Function for evalualting the kernel for a given distance.</div></div>
<div class="ttc" id="anamespacemelon_html"><div class="ttname"><a href="namespacemelon.html">melon</a></div><div class="ttdef"><b>Definition</b> kernel.h:21</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_bdd9a5d540de89e9fe90efdfc6973a4f.html">common</a></li><li class="navelem"><a class="el" href="dir_a065f42410ce59d310ee6ca453a28844.html">inc</a></li><li class="navelem"><a class="el" href="kernel_8h.html">kernel.h</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
